#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>


// struktura ktra bdzie odbierana
typedef struct {
   long type;
   char body[100];
} msg;

int main(){
   msg wiad; // zmienna do ktrej bd odbierane dane
   int id, result;
   strcpy(wiad.body, ""); // wyczyszczenie treci wiadomoci
   id = msgget(1642,0); // pobranie identyfikatora kolejki 
   if(id < 0){ // jeli nie udao si otworzy
      printf("Msggetrcv: %d\n", id); // to wywal komunikat
      exit(1); // i wyjd z programu
   }
   result = msgrcv(id, &wiad, sizeof(wiad.body), 0, 0); // odczytaj wiadomo
   // id - id kolejki
   // &wiad - referencja do zniemmej w ktrej bd zapisane odczytane dane
   // sizeof(...) dugo danych
   // 0, 0 - nie wane
   wiad.body[result] = 0; // dodanie zera na kocu odczytanej wiadomoci
   // znak o kodzie ASCII 0 oznacza koniec cigu tekstowego
   // w result jest ilo odczytanych znakw tak wic body[result] wskazuje
   // na znak nastpny po kocu komunikatu
   printf("%d: %s\n", result, wiad.body); // wywietlenie iloci znakw
   // i samego komunikatu
   msgctl(id, IPC_RMID, (struct msqid_ds *)0); // Usunicie wiadomoci z kolejki
   return 0;
}
